| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Public Attributes | List of all members
SmartRefBase Class Reference

User example objects: SmartRefBase. More...

`#include <GaudiKernel/SmartRefBase.h>`

Collaboration diagram for SmartRefBase:
[legend]

## Public Types
enum | { DATAOBJECT, CONTAINEDOBJECT }

## Public Member Functions
const ContainedObject * | accessData (const ContainedObject *typ) const
| Load on demand of ContainedObject like references. More...
const DataObject * | accessData (const DataObject *typ) const
| Load on demand of DataObject like references. More...
bool | isEqualEx (const DataObject *pObj, const SmartRefBase &c) const
| Extended equality check. More...
bool | isEqualEx (const ContainedObject *pObj, const SmartRefBase &c) const
| Extended equality check. More...
bool | isEqual (const ContainedObject *, const SmartRefBase &c) const
| Equality operator for ContainedObject like references. More...
bool | isEqual (const DataObject *, const SmartRefBase &c) const
| Equality operator for DataObject like references. More...
void | writeObject (const DataObject *pObject, StreamBuffer &s) const
| Output streamer for DataObject like references. More...
void | writeObject (const ContainedObject *pObject, StreamBuffer &s) const
| Output streamer for ContainedObject like references. More...
DataObject * | readObject (const DataObject *, StreamBuffer &s) const
| Input streamer for DataObject like references. More...
ContainedObject * | readObject (const ContainedObject *, StreamBuffer &s) const
| Output streamer for ContainedObject like references. More...
void | setObjectType (const ContainedObject *) const
void | setObjectType (const DataObject *) const
const std::string & | path () const
| Shortcut to access the path to the linked object. More...
int | objectType () const
void | set (DataObject *pObj, long hint_id, long link_id)
| Setup smart reference when reading. Must be allowed from external sources. More...

## Public Attributes
long | m_hintID
| Object data: ID of the link hint to the identifiable object. More...
long | m_linkID
| Object data: ID of the object within the identifiable container (if any) More...
const DataObject * | m_data
| Object data: Pointer to the identifiable object the link originates. More...
const ContainedObject * | m_contd
| Object data: Pointer to the Contained object (if applicable) More...
long | m_type

## Detailed Description

User example objects: SmartRefBase.

Description: Base class of SmartReference objects. The base class handles the object requests to the data store. The separation of the SmartReference and the base class is mainly to avoid code blow up, because if the object is not yet present serious work must be performed in order to request the object from the store and invoke object updates to keep pointers in sync.

Base Class: None

Dependencies: None

History :

    +---------+----------------------------------------------+--------+
    |    Date |                 Comment                      | Who    |
    +---------+----------------------------------------------+--------+
    | 21/06/99| Initial version.                             | MF     |
    +---------+----------------------------------------------+--------+

Author: M.Frank Version: 1.0

Definition at line 47 of file SmartRefBase.h.

## Member Enumeration Documentation

anonymous enum

Enumerator
DATAOBJECT |
CONTAINEDOBJECT |

Definition at line 60 of file SmartRefBase.h.

60 { DATAOBJECT, CONTAINEDOBJECT };
SmartRefBase::CONTAINEDOBJECT
Definition: SmartRefBase.h:60
SmartRefBase::DATAOBJECT
Definition: SmartRefBase.h:60

## Member Function Documentation

const ContainedObject * SmartRefBase::accessData | ( | const ContainedObject * | typ | ) | const

Load on demand of ContainedObject like references.

Load on demand: ContainedObject type references.

Definition at line 33 of file SmartRefBase.cpp.

33 {
34 if ( m_hintID != StreamBuffer::INVALID && m_linkID != StreamBuffer::INVALID ) {
35 const _Container* cnt = dynamic_cast<const _Container*>(accessData(m_data));
36 if ( cnt ) return cnt->containedObject(m_linkID);
37 }
38 return nullptr;
39 }
SmartRefBase::accessData
const ContainedObject * accessData(const ContainedObject *typ) const
Load on demand of ContainedObject like references.
Definition: SmartRefBase.cpp:33
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
ObjectContainerBase::containedObject
virtual ContainedObject * containedObject(long dist) const =0
Pointer to an object of a given distance.
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
ObjectContainerBase
ObjectContainerBase is the base class for Gaudi container classes.
Definition: ObjectContainerBase.h:19
StreamBuffer::INVALID
Definition: StreamBuffer.h:117

const DataObject * SmartRefBase::accessData | ( | const DataObject * | typ | ) | const

Load on demand of DataObject like references.

Load on demand: DataObject type references.

Definition at line 42 of file SmartRefBase.cpp.

42 {
43 DataObject* target = nullptr;
44 DataObject* source =nullptr;
45 if ( !m_data && m_contd ) m_data = m_contd->parent();
46 source = const_cast<DataObject*>(m_data);
47 if ( m_hintID != StreamBuffer::INVALID && source ) {
48 LinkManager* mgr = source->linkMgr();
49 if ( mgr ) {
50 LinkManager::Link* link = mgr->link(m_hintID);
51 if ( link ) {
52 target = link->object();
53 if ( !target ) {
54 IRegistry* reg = source->registry();
55 if ( reg ) {
56 IDataProviderSvc* datasvc = reg->dataSvc();
57 if ( datasvc && datasvc->retrieveObject(link->path(), target).isSuccess() ) {
58 link->setObject(target);
59 }
60 }
61 }
62 }
63 }
64 }
65 return target;
66 }
LinkManager::Link::path
const std::string & path() const
Access to path of object.
Definition: LinkManager.h:69
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
IDataProviderSvc
Data provider interface definition.
Definition: IDataProviderSvc.h:45
ContainedObject::parent
const ObjectContainerBase * parent() const
Access to parent object.
Definition: ContainedObject.h:49
DataObject::registry
IRegistry * registry() const
Get pointer to Registry.
Definition: DataObject.h:74
DataObject::linkMgr
LinkManager * linkMgr() const
Retrieve Link manager.
Definition: DataObject.h:78
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:56
LinkManager::Link::setObject
void setObject(const DataObject *pObject)
Update object pointer.
Definition: LinkManager.h:58
LinkManager::link
Link * link(long id)
Retrieve symbolic link identified by ID.
Definition: LinkManager.cpp:33
IRegistry::dataSvc
virtual IDataProviderSvc * dataSvc() const =0
Retrieve pointer to Transient Store.
IRegistry
The IRegistry represents the entry door to the environment any data object residing in a transient da...
Definition: IRegistry.h:22
StreamBuffer::INVALID
Definition: StreamBuffer.h:117
LinkManager::Link::object
const DataObject * object() const
Const access to data object.
Definition: LinkManager.h:62
LinkManager::Link
Embedded class defining a symbolic link Note: No copy constructor; bitwise copy (done by the compiler...
Definition: LinkManager.h:31
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:30
LinkManager
A LinkManager is the object aggregated into a DataObject, which is responsible for the handling of no...
Definition: LinkManager.h:21
IDataProviderSvc::retrieveObject
virtual StatusCode retrieveObject(IRegistry *pDirectory, const std::string &path, DataObject *&pObject)=0
Retrieve object identified by its directory entry.

bool SmartRefBase::isEqual | ( | const ContainedObject * | ,
|  | const SmartRefBase & | c
| ) |  | const
| inline

Equality operator for ContainedObject like references.

Definition at line 72 of file SmartRefBase.h.

72 {
73 return (m_hintID == c.m_hintID && m_linkID == c.m_linkID &&
74 m_data == c.m_data && m_contd == c.m_contd);
75 }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:56
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52

bool SmartRefBase::isEqual | ( | const DataObject * | ,
|  | const SmartRefBase & | c
| ) |  | const
| inline

Equality operator for DataObject like references.

Definition at line 77 of file SmartRefBase.h.

77 {
78 return m_linkID == c.m_linkID && m_data == c.m_data;
79 }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52

bool SmartRefBase::isEqualEx | ( | const DataObject * | pObj,
|  | const SmartRefBase & | c
| ) |  | const

Extended equality check.

Definition at line 69 of file SmartRefBase.cpp.

69 {
70 if ( c.m_hintID != StreamBuffer::INVALID && pObj ) {
71 DataObject* source = const_cast<DataObject*>(c.m_data);
72 if ( source ) {
73 LinkManager* mgr = source->linkMgr();
74 if ( mgr ) {
75 LinkManager::Link* link = mgr->link(c.m_hintID);
76 if ( link ) {
77 IRegistry* pReg = pObj->registry();
78 return pReg && link->path() == pReg->identifier();
79 }
80 }
81 }
82 }
83 return false;
84 }
LinkManager::Link::path
const std::string & path() const
Access to path of object.
Definition: LinkManager.h:69
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
DataObject::registry
IRegistry * registry() const
Get pointer to Registry.
Definition: DataObject.h:74
DataObject::linkMgr
LinkManager * linkMgr() const
Retrieve Link manager.
Definition: DataObject.h:78
IRegistry::identifier
virtual const id_type & identifier() const =0
Full identifier (or key)
LinkManager::link
Link * link(long id)
Retrieve symbolic link identified by ID.
Definition: LinkManager.cpp:33
IRegistry
The IRegistry represents the entry door to the environment any data object residing in a transient da...
Definition: IRegistry.h:22
StreamBuffer::INVALID
Definition: StreamBuffer.h:117
LinkManager::Link
Embedded class defining a symbolic link Note: No copy constructor; bitwise copy (done by the compiler...
Definition: LinkManager.h:31
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:30
LinkManager
A LinkManager is the object aggregated into a DataObject, which is responsible for the handling of no...
Definition: LinkManager.h:21

bool SmartRefBase::isEqualEx | ( | const ContainedObject * | pObj,
|  | const SmartRefBase & | c
| ) |  | const

Extended equality check.

Definition at line 87 of file SmartRefBase.cpp.

87 {
88 return isEqualEx(pObj->parent(), c) && pObj->index() == c.m_linkID;
89 }
gaudirun.c
c
Definition: gaudirun.py:391
SmartRefBase::isEqualEx
bool isEqualEx(const DataObject *pObj, const SmartRefBase &c) const
Extended equality check.
Definition: SmartRefBase.cpp:69
ContainedObject::index
virtual long index() const
Distance in the parent container.
Definition: ContainedObject.h:54
ContainedObject::parent
const ObjectContainerBase * parent() const
Access to parent object.
Definition: ContainedObject.h:49
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52

int SmartRefBase::objectType | ( |  | ) | const
| inline

Definition at line 111 of file SmartRefBase.h.

111 {
112 return m_type;
113 }
SmartRefBase::m_type
long m_type
Definition: SmartRefBase.h:58

const std::string & SmartRefBase::path | ( |  | ) | const

Shortcut to access the path to the linked object.

Definition at line 91 of file SmartRefBase.cpp.

91 {
92 static std::string s_empty_string{};
93 DataObject *source = nullptr;
94 if ( !m_data && m_contd ) m_data = m_contd->parent();
95 source = const_cast<DataObject*>(m_data);
96 if ( m_hintID != StreamBuffer::INVALID && source ) {
97 LinkManager* mgr = source->linkMgr();
98 if ( mgr ) {
99 LinkManager::Link* link = mgr->link(m_hintID);
100 if ( link )
101 return link->path();
102 }
103 }
104 return s_empty_string;
105 }
LinkManager::Link::path
const std::string & path() const
Access to path of object.
Definition: LinkManager.h:69
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
ContainedObject::parent
const ObjectContainerBase * parent() const
Access to parent object.
Definition: ContainedObject.h:49
DataObject::linkMgr
LinkManager * linkMgr() const
Retrieve Link manager.
Definition: DataObject.h:78
std::string
STL class.
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:56
LinkManager::link
Link * link(long id)
Retrieve symbolic link identified by ID.
Definition: LinkManager.cpp:33
StreamBuffer::INVALID
Definition: StreamBuffer.h:117
LinkManager::Link
Embedded class defining a symbolic link Note: No copy constructor; bitwise copy (done by the compiler...
Definition: LinkManager.h:31
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:30
LinkManager
A LinkManager is the object aggregated into a DataObject, which is responsible for the handling of no...
Definition: LinkManager.h:21

DataObject* SmartRefBase::readObject | ( | const DataObject * | ,
|  | StreamBuffer & | s
| ) |  | const
| inline

Input streamer for DataObject like references.

Definition at line 89 of file SmartRefBase.h.

89 {
90 DataObject* pObj = 0;
91 s.getIdentifiedLink(pObj, m_hintID);
92 return pObj;
93 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:30
StreamBuffer::getIdentifiedLink
void getIdentifiedLink(DataObject *&pObject, long &hint)
Definition: StreamBuffer.h:315

ContainedObject* SmartRefBase::readObject | ( | const ContainedObject * | ,
|  | StreamBuffer & | s
| ) |  | const
| inline

Output streamer for ContainedObject like references.

Definition at line 95 of file SmartRefBase.h.

95 {
96 ContainedObject* pObj = 0;
97 s.getContainedLink(pObj, m_hintID, m_linkID);
98 return pObj;
99 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
ContainedObject
All classes that their objects may be contained in an LHCb ObjectContainer (e.g.
Definition: ContainedObject.h:29
StreamBuffer::getContainedLink
void getContainedLink(ContainedObject *&pObject, long &hint, long &link)
Definition: StreamBuffer.h:325

void SmartRefBase::set | ( | DataObject * | pObj,
|  | long | hint_id,
|  | long | link_id
| ) |  |

Setup smart reference when reading. Must be allowed from external sources.

Setup smart reference.

Definition at line 26 of file SmartRefBase.cpp.

26 {
27 m_data = pObj;
28 m_hintID = hint_id;
29 m_linkID = link_id;
30 }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52

void SmartRefBase::setObjectType | ( | const ContainedObject * |  | ) | const
| inline

Definition at line 100 of file SmartRefBase.h.

100 {
101 m_type = CONTAINEDOBJECT;
102 }
SmartRefBase::CONTAINEDOBJECT
Definition: SmartRefBase.h:60
SmartRefBase::m_type
long m_type
Definition: SmartRefBase.h:58

void SmartRefBase::setObjectType | ( | const DataObject * |  | ) | const
| inline

Definition at line 103 of file SmartRefBase.h.

103 {
104 m_type = DATAOBJECT;
105 }
SmartRefBase::DATAOBJECT
Definition: SmartRefBase.h:60
SmartRefBase::m_type
long m_type
Definition: SmartRefBase.h:58

void SmartRefBase::writeObject | ( | const DataObject * | pObject,
|  | StreamBuffer & | s
| ) |  | const
| inline

Output streamer for DataObject like references.

Definition at line 81 of file SmartRefBase.h.

81 {
82 s.addIdentifiedLink(pObject, m_hintID);
83 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
StreamBuffer::addIdentifiedLink
void addIdentifiedLink(const DataObject *pObject, long hint)
Definition: StreamBuffer.h:321

void SmartRefBase::writeObject | ( | const ContainedObject * | pObject,
|  | StreamBuffer & | s
| ) |  | const
| inline

Output streamer for ContainedObject like references.

Definition at line 85 of file SmartRefBase.h.

85 {
86 s.addContainedLink(pObject, m_hintID, m_linkID);
87 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
StreamBuffer::addContainedLink
void addContainedLink(const ContainedObject *pObject, long hint, long link)
Definition: StreamBuffer.h:332

## Member Data Documentation

const ContainedObject* SmartRefBase::m_contd
| mutable

Object data: Pointer to the Contained object (if applicable)

Definition at line 56 of file SmartRefBase.h.

const DataObject* SmartRefBase::m_data
| mutable

Object data: Pointer to the identifiable object the link originates.

Definition at line 54 of file SmartRefBase.h.

long SmartRefBase::m_hintID
| mutable

Object data: ID of the link hint to the identifiable object.

Definition at line 50 of file SmartRefBase.h.

long SmartRefBase::m_linkID
| mutable

Object data: ID of the object within the identifiable container (if any)

Definition at line 52 of file SmartRefBase.h.

long SmartRefBase::m_type
| mutable

Definition at line 58 of file SmartRefBase.h.

The documentation for this class was generated from the following files:

- GaudiKernel/GaudiKernel/SmartRefBase.h
- GaudiKernel/src/Lib/SmartRefBase.cpp